RAM_CODE_TARGET = updater-ram-code
target = $(RAM_CODE_TARGET)
OBJDIR = obj
CFILES = main.c startup.c hex-parser.c
CFILES += fatfs/ff.c fatfs/diskio.c fatfs/ffsystem.c fatfs/ffunicode.c fatfs/shimatta_sdio_driver/shimatta_sdio.c
LINKER_SCRIPT = ram-link.ld
MAPFILE = $(RAM_CODE_TARGET)
PREFIX = arm-none-eabi-

CC = $(PREFIX)gcc
OBJCOPY = $(PREFIX)objcopy
SIZE = $(PREFIX)size

ifneq ($(VERBOSE),true)
QUIET=@
else
QUIET=
endif


DEFINES = -DSTM32F407xx -DSTM32F4XX -DHSE_VALUE=8000000UL
INCLUDEPATH = -Iinclude

LFLAGS = -mlittle-endian -mthumb -mcpu=cortex-m4 -mthumb-interwork
LFLAGS += -mfloat-abi=hard -mfpu=fpv4-sp-d16 --disable-newlib-supplied-syscalls -nostartfiles
LFLAGS += -T$(LINKER_SCRIPT) -Wl,-Map=$(MAPFILE).map -Wl,--print-memory-usage -g3

CFLAGS = -c -mlittle-endian -mthumb -mcpu=cortex-m4 -mthumb-interwork -Os -g3
CFLAGS += -mfloat-abi=hard -mfpu=fpv4-sp-d16 -nostartfiles
CFLAGS += -Wall -Wextra -Wold-style-declaration -Wuninitialized -Wmaybe-uninitialized -Wunused-parameter -Wimplicit-fallthrough=3 -Wsign-compare

OBJ = $(CFILES:%.c=$(OBJDIR)/%.c.o)

default: $(RAM_CODE_TARGET).bin.h

all: $(RAM_CODE_TARGET).bin.h

%.bin.h: %.bin
	@echo "[BIN2H] $@"
	$(QUIET)python bin2carray.py $@ $^

$(RAM_CODE_TARGET).bin: $(RAM_CODE_TARGET).elf
	@echo "[ELF2BIN] $@"
	$(QUIET)$(OBJCOPY) -O binary $^ $@

$(RAM_CODE_TARGET).elf: $(OBJ) $(LINKER_SCRIPT)
	@echo [LD] $@
	$(QUIET)$(CC) $(LFLAGS) $(LIBRARYPATH) -o $@ $(OBJ) $(ASOBJ) $(LIBRARIES)
	$(QUIET)$(SIZE) $@
	
$(OBJ):
	@echo [CC] $@
	$(eval OUTPATH=$(dir $@))
	@mkdir -p $(OUTPATH)
	$(QUIET)$(CC) $(CFLAGS) -MMD -MT $@ $(INCLUDEPATH) $(DEFINES) -o $@ $(@:$(OBJDIR)/%.c.o=%.c)

.PHONY: clean qtproject

clean:
	@echo [CLEAN]
	$(QUIET)rm -f $(OBJ) $(MAPFILE).map $(CFILES:%.c=$(OBJDIR)/%.c.d) $(RAM_CODE_TARGET).bin $(RAM_CODE_TARGET).elf $(RAM_CODE_TARGET).bin.c

qtproject:
	$(QUIET)rm -f $(target).files $(target).cflags $(target).config $(target).creator $(target).includes $(target).creator.user
	@echo "Generating source file list"
	$(QUIET)echo "$(CFILES)" | tr ' ' '\n' > $(target).files
	@echo -n "Appending found header files from folders "
	@echo `echo $(INCLUDEPATH) | sed "s/-I//g"`
	$(QUIET)for dir in `echo $(INCLUDEPATH) | sed "s/-I//g"`; do \
		find `echo "$${dir}"` -name "*.h" >> $(target).files; \
	done
	@echo "Generating $(target).cflags"
	$(QUIET)echo "" > $(target).cflags
	@echo "Generating $(target).includes"
	$(QUIET)echo $(INCLUDEPATH) | sed "s/-I/,/g" | tr , '\n' | sed "/^$$/d" > $(target).includes;
	@echo "Generating $(target).config"
	$(QUIET)echo $(DEFINES) | sed "s/-D/,#define /g" | tr , '\n' | sed "/^$$/d" > $(target).config
	@echo "Generating $(target).creator"
	$(QUIET)echo "[GENERAL]" > $(target).creator

-include $(CFILES:%.c=$(OBJDIR)/%.c.d)

